#include <Tlc5940.h>

#define MSG_LEN          34
#define DISTANCE_COUNT   5
#define DISTANCE_SAMPLES 1
#define DISTANCE_FUZZ 10
#define MAX_DISTANCE 40
#define LED_COUNT 8
#define SERVO_COUNT 12


byte distance[5]={0,0,0,0,0};
byte position[9]={0,0,0,0,0,0,0,0,0};
int modifier[]={0,0,0,0, 0,0,0,0};
byte modifierCurrent[]={0,0,0,0, 0,0,0,0};
int modifierLast[]={0,0,0,0, 0,0,0,0};

byte servoPins[]={24,25,26,27,28,29,30,31,32,33,34,35};
byte servoPosition[]={0,0,0,0,0,0,0,0,0,0,0,0};
byte servoLast[]={0,0,0,0,0,0,0,0,0,0,0,0};
byte servoCurrent[]={0,0,0,0,0,0,0,0,0,0,0,0};

byte program = 0;
byte value = 0;
long loopTimer;


typedef struct {
  byte r;
  byte g;
  byte b;
  byte w;
} RGBW;

RGBW leds[8]; 

#include "color_fns.h"
#include "mod_programs.h"
#include "mod_fades.h"

#include <Servo.h> 
 
Servo servo[12]; 


 
void readColorSerial()
{
  if(Serial1.available()>=MSG_LEN){

    program = Serial1.read();
    value = Serial1.read();
    for(int i=0;i<LED_COUNT;i++){
      leds[i].r = Serial1.read();
      leds[i].g = Serial1.read();
      leds[i].b = Serial1.read();
      leds[i].w = Serial1.read();
    }
  }
  Serial1.flush();
  Serial1.print('A');
// Serial.print('A');
  
}

void readModifierSerial()
{
  if(Serial3.available()>=DISTANCE_COUNT ){

   
    for(int i=0;i<DISTANCE_COUNT ;i++){
      distance[i] = Serial3.read();
      /*
      Serial.print( distance[i], DEC);
     Serial.print(',', BYTE);//*/
    }
  // Serial.print(10, BYTE);
  }
  Serial3.flush();
  Serial3.print('A');
// Serial.print('A');
  
}

void updatePositions() 
{
//map sensors to channels //detect were people aren't

//rather have too much modified than not enough

//  1 2   3 4   5 6   7 8
//S L L S L L S L L S L L S
//1     2     3     4     5
//   *         *   *              


  byte sensorCount = 0;
  for(byte i = 0; i<=LED_COUNT; i++) {
    if(i % 2 == 1){ //odd
    //i =8 sc =4
       position[i] = (distance[sensorCount] + distance[sensorCount+1])/2;
       sensorCount++; 
    } else { //even
      position[i] = distance[sensorCount];
      
    }
    //set max distance
   if(position[i] >  MAX_DISTANCE) {
     position[i] = 0;
   } else {
    //invert values 
    position[i] = map(position[i],MAX_DISTANCE,5,0,255);
   }
  

/*   
Serial.print(position[i], DEC);
  Serial.print(',', BYTE);//*/
  }
  
//  Serial.print(10, BYTE);
}

void setModifiers()
{

  /*
S0 -> P0 S0          \
                      M0
      P1 S0+S1      <
                      M1 
S1 -> P2 S1         <
                      M2 
      P3 S1+S2      <
                      M3 
S2 -> P4  S2        <
                      M4 
      P5 S2+S3      < 
                      M5 
S3 -> P6 S3         <
                      M6 
      P7 S3+S4      <
                      M7 
S4 -> P8 S5         / 

*/
  
  
  for(byte i=0; i<LED_COUNT;i++) {
   // modifier[i] = constrain(position[i]+ position[i+1],0,255);
   // modifier[i] = (position[i]+ position[i+1])/2;
   modifierLast[i] = modifier[i];
   modifier[i] = max(position[i], position[i+1]);
    //modifierLast[i] = modifier[i];
   /*
   Serial.print(modifier[i], DEC);
  Serial.print(',', BYTE);//*/
  }
  
  //Serial.print(10, BYTE);
}
//test with out fades
/*
void setFades()
{
  for(byte i=0; i<LED_COUNT;i++) {

     modifierCurrent[i] = modifier[i];
  }
}//*/

//*


void setFades()
{
  for(byte i=0; i<=LED_COUNT;i++) {
   //if(modifier[i] == modifierCurrent[i] && modifier[i] != modifierLast[i]) {
    if(Mod_isFading(i) == false){
   //if(modifier[i] != modifierLast[i]) {
      //Mod_removeFades(i);
      uint16_t duration = 2000;
      uint32_t startMillis = millis();
      uint32_t endMillis = startMillis + duration;
      Mod_addFade(i, modifierLast[i], modifier[i], startMillis, endMillis);
    }
    else {
      //Serial.print('F', BYTE);
    }
  /*
  Serial.print(modifierCurrent[i], DEC);
  Serial.print(',', BYTE);//*/
  }
  
//  Serial.print(10, BYTE);
}  

//

long servoTimer = millis();
byte servoCount = 0;
void moveServos() 
{
//  if(servoTimer +15 < millis())
//  {
    for(byte i = 0; i < SERVO_COUNT/3; i++) {
      int mod = 100 - constrain((modifier[i*2]+modifier[i*2+1])/2,0,100);
      mod -= mod % 3;
      for(byte k = 0; k < 3; k++) {
        if(servoCurrent[servoCount] != servoPosition[servoCount]) {
         if(servoCurrent[servoCount] < servoPosition[servoCount]) {
            servoCurrent[servoCount] += 3;
          } else {
            servoCurrent[servoCount] -= 3;
          }
          servo[servoCount].write(servoCurrent[servoCount]); 
          Serial.print('S', BYTE);//*//**/
        } else {
          Serial.print(mod, DEC);
          Serial.print('M', BYTE);
          servoPosition[servoCount] = mod;
        }
        //*
       Serial.print(servoCurrent[servoCount], DEC);
     Serial.print(',', BYTE);//*/
    //  delay(10);
      servoCount++;
  }
  
 

    }
    servoCount = 0;
     Serial.print(10, BYTE);
//  }
}




void runProgram(){
   switch (program) {

    case 1:
       //glow where people are
      lightOnly() ;
      break;
    case 2:
      //glow white
      glowWhite();
      break;
    case 3:  
       //shift hue
      shiftHue();
      break;
    case 4:  
        //drop sateration
        dropSaturation();
      break; 
      
    case 5:
        //increase brightness
        increaseBrightness() ;
      break;
    default:    
     break;
  }   
}

void updateTLC(){
  for(int i =0;i<LED_COUNT;i++){
   //int LEDval=map(PWMData[i], 0, 255, 4095, 0); //(255-PWMData[i]))*16;
    Tlc.set(i*4  , map(leds[i].r, 0, 255, 4095, 0));
    Tlc.set(i*4+1, map(leds[i].g, 0, 255, 4095, 0));
    Tlc.set(i*4+2, map(leds[i].b, 0, 255, 4095, 0));
    Tlc.set(i*4+3, map(leds[i].w, 0, 255, 4095, 0));
 /*   
      Serial.print(leds[i].r, DEC);
      Serial.print(leds[i].g, DEC);
      Serial.print(leds[i].b, DEC);
      Serial.print(leds[i].w, DEC);
      Serial.print(',', BYTE);//*/
    }
 //  Serial.print(10, BYTE);
}




void setup()
{
  Serial3.begin(115200);
  Serial1.begin(115200);
  Serial.begin(115200);
  Tlc.init();
  Serial1.print('A');
  Serial3.print('A');
  loopTimer = millis();
  
  for(byte i=0; i < SERVO_COUNT; i++) {
      servo[i].attach(servoPins[i]);
  }
  
}





void loop()
{
  if(loopTimer+33 < millis()){
    loopTimer = millis();
    readColorSerial();
    readModifierSerial();
     updatePositions();
      setModifiers();
      setFades();
      Mod_updateFades();
  moveServos();

    
    
    runProgram();
    updateTLC();
    Tlc.update();  
  }
} 

