#define DISTANCE_COUNT   5
#define DISTANCE_SAMPLES 1
#define DISTANCE_FUZZ 10
#define MAX_DISTANCE 60
#define LED_COUNT 8

byte distance[5]={0,0,0,0,0};
unsigned int distanceRaw[5]={0,0,0,0,0};

byte distancePins[5]={2,3,4,5,6};
byte distanceStrobePin = 9;
byte distanceCount = 0;

long loopTimer;

boolean readSerial()
{
  if(Serial.available() && (Serial.read()==65)) {
    return true;
  }

  Serial.flush();
  return false;
}

void sendSerial() 
{
    for(int i=0; i<5; i++) {
      Serial.print(distance[i], BYTE);
    }
}

long pulse;

void updateDistances() 
{
  //send pulse to sync sensors
  digitalWrite(distanceStrobePin, HIGH);
  delayMicroseconds(20);
  digitalWrite(distanceStrobePin, LOW);
  //Used to read in the pulse that is being sent by the MaxSonar device.
  //Pulse Width representation with a scale factor of 147 uS per Inch.
  for(byte i = 0; i < DISTANCE_COUNT; i++) {
    //pulse = 100;
    pulse = pulseIn(distancePins[i], HIGH)/147;
    if(pulse == 0){ //sometimes the pulse fails try again;
      pulse = pulseIn(distancePins[i], HIGH)/147;
    }
  distance[i] = pulse;
  }
}

void setup()
{
  for(byte i = 0; i< DISTANCE_COUNT; i++) {
    pinMode(distancePins[i], INPUT);
  }
  pinMode(distanceStrobePin, OUTPUT);
  digitalWrite(distanceStrobePin, LOW); 
  
  Serial.begin(115200);
  loopTimer = millis();
}

void loop()
{
  updateDistances();
  if(loopTimer+33 < millis()){
    if(readSerial()){
      loopTimer = millis();
      sendSerial();
    }
  } 
}

